// labyrint.h : main header file for the LABYRINT DLL
//

#if !defined(AFX_LABYRINT_H__3C580026_2C7D_11D2_8548_944D03C10627__INCLUDED_)
#define AFX_LABYRINT_H__3C580026_2C7D_11D2_8548_944D03C10627__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

typedef struct {
    int
	iXsize,
	iYsize,
	iZsize;
    unsigned char
	*data;
} LABYRINTH;

/* Prototypes
LABYRINTH		*labcreate( int xs, int ys, int zs );
void			labdestroy( LABYRINTH *l );
unsigned char	labgetpos( LABYRINTH *l, int x, int y, int z );
void			labsetpos( LABYRINTH *l, int x, int y, int z, int value );
*/

typedef LABYRINTH		*(CALLBACK* Llabcreate)(int,int,int);
typedef void			*(CALLBACK* Llabdestroy)(LABYRINTH *);
typedef unsigned char	(CALLBACK* Llabgetpos)(LABYRINTH *,int,int,int);
typedef void			*(CALLBACK* Llabsetpos)(LABYRINTH *,int,int,int,int);

HINSTANCE			dllLab=NULL;
Llabcreate			labcreate;
Llabdestroy			labdestroy;
Llabgetpos			labgetpos;
Llabsetpos			labsetpos;

int labinit() {
	int retval=0;

	if( dllLab ) retval=1;
	else if( (dllLab = LoadLibrary("labyrint.dll")) ) {
		retval=2;

		labcreate	= (Llabcreate)GetProcAddress(dllLab, "_labcreate");
		labdestroy	= (Llabdestroy)GetProcAddress(dllLab, "_labdestroy");
		labsetpos	= (Llabsetpos)GetProcAddress(dllLab, "_labsetpos");
		labgetpos	= (Llabgetpos)GetProcAddress(dllLab, "_labgetpos");
	}
	return retval;
}

#define labexit() if(dllLab) {FreeLibrary(dllLab);dllLab=NULL;}

/////////////////////////////////////////////////////////////////////////////
// CLabyrintApp
// See labyrint.cpp for the implementation of this class
//

class CLabyrintApp : public CWinApp
{
public:
	CLabyrintApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLabyrintApp)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CLabyrintApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LABYRINT_H__3C580026_2C7D_11D2_8548_944D03C10627__INCLUDED_)
